

package interfaceProofTree;
import javax.swing.*; // JPanel (entre otros)
import java.awt.*; // para borderLayout


public class StatusPanel extends JPanel {
   ImageIcon nonvalidIcon,buggyIcon,validIcon,dontknowIcon,trustedIcon;
   JLabel lNonValid, lBuggy, lValid, lDontKnow, lTrusted, lTotal;
   int nNonValid, nBuggy, nValid, nDontKnow, nTrusted, nTotal;


   public StatusPanel(ImageIcon theNonvalidIcon,
                      ImageIcon theValidIcon,
                      ImageIcon theBuggyIcon,
                      ImageIcon theDontknowIcon,
                      ImageIcon theTrustedIcon) {

     final int gap=1; // separation between the icon and its label

     nonvalidIcon = theNonvalidIcon;
     validIcon    = theValidIcon;
     buggyIcon    = theBuggyIcon;
     dontknowIcon = theDontknowIcon;
     trustedIcon  = theTrustedIcon;

     nNonValid = nBuggy = nValid = nDontKnow=  nTrusted = nTotal=0;

      //setLayout(new FlowLayout());
     setLayout(new GridLayout(2,3,-1,-1));

     JPanel validPanel = new JPanel();
     JLabel labelValid = new JLabel("Valid: ");
     labelValid.setIcon((Icon) validIcon);
     labelValid.setIconTextGap(gap);
     validPanel.add(labelValid);
     lValid = new JLabel("  ");
     validPanel.add(lValid);
     add(validPanel);

     JPanel nonValidPanel = new JPanel();
     JLabel labelNonValid = new JLabel("NonValid: ");
     labelNonValid.setIcon((Icon) nonvalidIcon);
     labelNonValid.setIconTextGap(gap);
     nonValidPanel.add(labelNonValid);
     lNonValid = new JLabel("  ");
     nonValidPanel.add(lNonValid);
     add(nonValidPanel);

     JPanel unknownPanel = new JPanel();
     JLabel labelDontKnow = new JLabel("Unknown: ");
     labelDontKnow.setIcon((Icon) dontknowIcon);
     labelDontKnow.setIconTextGap(gap);
     unknownPanel.add(labelDontKnow);
     lDontKnow = new JLabel("  ");
     unknownPanel.add(lDontKnow);
     add(unknownPanel);

     JPanel trustedPanel = new JPanel();
     JLabel labelTrusted = new JLabel("Trusted: ");
     labelTrusted.setIcon((Icon) trustedIcon);
     labelTrusted.setIconTextGap(gap);
     trustedPanel.add(labelTrusted);
     lTrusted = new JLabel("  ");
     trustedPanel.add(lTrusted);
     add(trustedPanel);

     JPanel buggyPanel = new JPanel();
     JLabel labelBuggy = new JLabel("Buggy: ");
     labelBuggy.setIcon((Icon) buggyIcon);
     labelBuggy.setIconTextGap(gap);
     buggyPanel.add(labelBuggy);
     lBuggy = new JLabel("  ");
     buggyPanel.add(lBuggy);
     add(buggyPanel);

     JPanel totalPanel = new JPanel();
     JLabel labelTotal = new JLabel("Total: ");
     totalPanel.add(labelTotal);
     lTotal = new JLabel("  ");
     totalPanel.add(lTotal);
     add(totalPanel);

   }  // StatusPanel

   public void setValues(int valid, int nonValid, int dontKnow, int buggy, int trusted) {
    nNonValid = nonValid;
    nBuggy = buggy;
    nValid = valid;
    nDontKnow = dontKnow;
    nTrusted = trusted;
    nTotal = nNonValid +  nBuggy + nValid + nDontKnow + nTrusted;
    repaint();
   }

   public void paint(Graphics g) {

   Integer valid = new Integer(nValid);
   Integer nonValid = new Integer(nNonValid);
   Integer dontKnow = new Integer(nDontKnow);
   Integer buggy = new Integer(nBuggy);
   Integer trusted = new Integer(nTrusted);
   Integer total = new Integer(nTotal);

   lValid.setText(valid.toString()+" ");
   lNonValid.setText(nonValid.toString()+" ");
   lBuggy.setText(buggy.toString()+" ");
   lTrusted.setText(trusted.toString()+" ");
   lDontKnow.setText(dontKnow.toString()+" ");
   lTotal.setText(total.toString()+" ");
   super.paint(g);
   } // update

} // StatusPanel
