/*
 * Created on 25-sep-2005
 *
 */
package terms;

import java.util.TreeSet;
import java.util.Vector;
/**
 * @author Rafa Caballero
 *
 */
public class HeadTailList extends Term {
	private Vector head;
	private Term tail;
	
	public HeadTailList() { head= null; tail = null;}
	public HeadTailList(Vector head,Term tail) { 
		this.head = head; 
		this.tail = tail;
	}
	public String toString() { 
		String result = "[ ";
		for (int i=0; i<head.size();i++) {
			Term t = (Term) head.elementAt(i);
			result += t+"";
			if (i<head.size()-1) result +=", ";
		}
		
		// now the tail
		result += " | "+tail+" ]";
		return result; 
	}
	
	public Vector getHead() {return head;}
	public void setHead(Vector head) {this.head = head;}
	
	public Term getTail() { return tail; }
	public void setTail(Term tail) { this.tail = tail; }
	
    /**
     *  Variables in this term.
     */
	public TreeSet variables() {
	   TreeSet t = tail.variables();	
	   TreeSet t2;
	  for (int i=0; i<head.size(); i++) {
	   	 		t2 = ((Term)head.elementAt(i)).variables();
	   	 		if (t2 != null) {
	   	 			if (t==null) t = new TreeSet();
	   	 			t.addAll(t2);
	   	 		}
	  }
	  return t;
	}

}
